const baseUrl = 'https://www.zhuandan.com'

chrome.webRequest.onCompleted.addListener(function(details) {
    const { tabId, url } = details

    if (url.indexOf('e.dianping.com/ktv/dzbook/online/api/queryOrders.wbc') !== -1) {
        const todo = {
            action: 'addButtons@dianping',
            url,
            auto: localStorage.getItem('auto')
        }
        chrome.tabs.sendMessage(tabId, todo);
    }
}, {
    urls: ["http://*/*", "https://*/*"],
    types: ["xmlhttprequest"]
})

chrome.runtime.onMessage.addListener(function(request, sender, sendResponse) {
    const ajaxParam = {}
    if (request.action == 'saveOrder') {
        ajaxParam.endPoint = baseUrl + '/Groupser/BrowserImport'
        ajaxParam.method = 'POST'
        ajaxParam.param = JSON.stringify(request.data)
        ajaxParam.contentType = 'application/json'
        ajaxParam.goodCallback = function (responseText) {
            console.log(request.data)
            const { status, message } = responseText
            sendResponse({ status, message, order_no: request.data.order_no })
        }
        ajaxParam.badCallback = function (responseText) {}
    }

    if (request.action == 'checkOrderStatus') {
        ajaxParam.endPoint = baseUrl + '/Groupser/checkorderexist?order_no=' + request.id
        ajaxParam.method = 'GET'
        ajaxParam.param = ''
        ajaxParam.contentType = ''
        ajaxParam.goodCallback = function (responseText) {
            const { status } = responseText
            sendResponse({ status })
        }
        ajaxParam.badCallback = function (responseText) {}
    }

    if (ajaxParam.endPoint) {
        ajaxCall(ajaxParam)
    }

    return true
})
function ajaxCall({ endPoint, method, param, contentType, goodCallback, badCallback }) {
    location.replace(baseUrl)
    $.ajax({
        url: endPoint,
        type: method,
        data: param,
        headers: {
            Accept: 'application/json, text/plain, */*'
        },
        contentType,
        processData: false,
        success: goodCallback,
        error: badCallback
    })
}