chrome.runtime.onMessage.addListener(function(req, sender, sendResponse) {
    const { action, url, auto } = req
    if (action == 'addButtons@dianping') {
        setTimeout(function(){
            addButtons(url, auto)
        }, 1500)
    }
})


function addButtons(url, auto) {
    const orders = $('.order-list .card')
    orders.find('.btn-import').remove()
    addButton(0, auto)

    function bindButton(auto) {
        $('.btn-import').on('click', function() {
            const that = this
            const index = $(this).attr('data-index')
            const $info = orders.eq(index)

            const source_id = $info.find('.order-number').text().replace('订单号：', '')
            const datetime = $info.find('.order-create-time').text().replace('下单时间：', '')
            const receiver = $info.find('.order-receiver .form-value').text()
            const receivers = receiver.split(' ')
            const buyer_phone = $info.find('.order-orderer .form-value').text().replace(/(\d+) /, '$1')
            const amount = $info.find('.order-payment-amount .form-value').text().replace(/¥ (\d+)(\.\d+)*（包含配送费 ¥ \d+）/, '$1$2')
            const address = $info.find('.order-delivery-address .form-value').text().replace(/ \| [\d.]+km/, '')
            const deliveryType = $info.find('.order-delivery-type .form-value').text()
            const delivery_date = $info.find('.order-delivery-time .form-value').text().substr(0, 10)
            const delivery_time = $info.find('.order-delivery-time .form-value').text().substr(12)
            const card_con = $info.find('.order-postcard .form-value').text()
            const goods_desc = $info.find('.product-item-name').text()
            const goods_name = $info.find('.product-name').text()
            const goods_number = $info.find('.order-quantity .form-value').text()
            const goods_cover = $info.find('.product-img').attr('src')
            const remark = $info.find('.order-customer-remark .form-value').text()

            const data = {
                order_no: source_id, 
                crated_at: datetime, 
                consignee: receivers[0], 
                phone: receivers[1],
                buyer_phone, 
                amount,
                address: address ? address : deliveryType,
                delivery_date,
                delivery_time,
                card_con, 
                goods_desc,
                goods_name,
                goods_number,
                goods_cover,
                remark: remark + ' ' + '配送方式：' + deliveryType, 
            }

            data.card_con = data.card_con.replace('&', '%26')
            data.address = data.address.replace('&', '%26')
            if(!/\d+/.test(data.buyer_phone)) {
                delete data.buyer_phone
            }


            chrome.runtime.sendMessage({
                action: 'saveOrder', 
                data: data,
            }, function(res) {
                if (res.status !== 0 && res.status !== 46000) {
                    GrowlNotification.notify({
                        title: '错误!',
                        description: `<div>${res.order_no}</div><div>${res.message}</div>`,
                        type: 'error',
                        position: 'top-right',
                        closeTimeout: 5000
                    })
                    return
                } else {
                    $(that).off('click').addClass('disabled').text('已导入')
                }
            })
        })
        if (auto === '1') {
            const targetDom = $('.btn-import')
            targetDom.click()
        }
    }

    function checkOrderStatus(index) {
        const id = orders.eq(index).find('.order-number').text().replace('订单号：', '')
        chrome.runtime.sendMessage({
            action: 'checkOrderStatus', 
            id: id,
        }, function(res) {
            if (res.status === 46000) $('.btn-import[data-index=' + index + ']').off('click').attr('disabled', 'disabled').addClass('disabled').text('已导入')
        });
    }

    function addButton(index, auto) {
        if (index == orders.length) {
            bindButton(auto)
            return
        }

        $button = $('<button type="button" class="btn btn-primary btn-import" data-index="' + index + '">导入订单</button>')
        $('.card-content').eq(index).find('.order-attr-info').append($button)
        checkOrderStatus(index)

        index++
        addButton(index, auto)
    }
}